# -*- coding: utf-8 -*-
from openerp.addons.base.maintenance.migrations import util

def migrate(cr, version):
    env = util.env(cr)
    pack_product_ids = env['product.product'].search([('name', 'like', 'Pack v9'), ('active', 'in', [False,True])])
    cr.execute("""
        SELECT p.id FROM project_project p, account_analytic_account a WHERE a.name like 'Quickstart %' AND p.analytic_account_id=a.id
        """)
    quickstart_ids = [row['id'] for row in cr.dictfetchall()]
    cr.execute("""
        SELECT a.id,a.partner_id,a.quantity_max,a.pricelist_id,t.name,a.manager_id,a.company_id,a.template_id
        FROM account_analytic_account a, account_analytic_account t
        WHERE a.contract_type='prepaid' AND
              a.state='open' AND
              t.name ilike '%pack'
              AND t.id=a.template_id
        """)
    to_migrate = cr.dictfetchall()
    # yes, it's hardcoded, i know
    packs = {
        30483: {'product': pack_product_ids.filtered(lambda r: 'Basic' in r.name), 'quote_template_id': 10, 'hours': 25},
        30484: {'product': pack_product_ids.filtered(lambda r: 'Standard' in r.name), 'quote_template_id': 11, 'hours': 50},
        30485: {'product': pack_product_ids.filtered(lambda r: 'Custom' in r.name), 'quote_template_id': 12, 'hours': 100},
        38449: {'product': pack_product_ids.filtered(lambda r: 'Pro' in r.name), 'quote_template_id': 16, 'hours': 200},
    }
    for account in to_migrate:
        pack = packs[account['template_id']]
        line_vals = [(0, False, {'product_id': pack['product'].id,
                                 'name': pack['product'].name,
                                 'product_uom_qty': int(account['quantity_max'] / pack['hours']),
                                 'product_uom': pack['product'].uom_id.id,
                                 'price_unit': 0.0,
                                 })]
        so_vals = {
            'partner_id': account['partner_id'],
            'project_id': account['id'],
            'pricelist_id': account['pricelist_id'],
            'order_line': line_vals,
            'user_id': account['manager_id'],
            'note': 'This order was created to preserve our support contracts in a usable form during the migration to Odoo 9. This order MUST NOT be invoiced, since it already has been invoiced when the initial pack was sold to the customer. Contact @phu, @dbo or @odo for more details.',
            'origin': 'MIG:PREPAID_SUPPORT',
            'state': 'sale',
            'company_id': account['company_id'],
            'template_id': pack['quote_template_id'],
        }
        order = env['sale.order'].with_context(mail_notrack=True).create(so_vals)
        # we want to avoid the automatic task creation that will take place if we confirm
        # but we still need the procurement for everything to be correct in the end
        # let's do it manually
        proc_group_vals = order._prepare_procurement_group()
        order.procurement_group_id = env['procurement.group'].create(proc_group_vals)
        proc_vals = order.order_line._prepare_order_line_procurement(group_id=order.procurement_group_id.id)
        proc_vals['state'] = 'done'
        proc = env['procurement.order'].with_context(procurement_autorun_defer=True).create(proc_vals)
        task = env['project.task'].search([('analytic_account_id', '=', account['id']), ('project_id', 'in', quickstart_ids)])
        if task:
            task.write({'procurement_id': proc.id})
        for line in order.timesheet_ids:
            line.so_line = order.order_line
